/*
   I, the copyright holder of this work, hereby release it into the public
   domain. This applies worldwide. In case this is not legally possible: I
   grant anyone the right to use this work for any purpose, without any
   conditions, unless such conditions are required by law.
*/

#include "fernandotel.h"

void pick_target(struct ncdirect *nc, struct Player *player, struct Player *players) {
    struct Player **targets;
    char *str;
    unsigned short i, player_id;
    bool npc_killer = false;

    if (count_players(players, PLAYER_ALIVE) <= 1)
        npc_killer = true;

    printf("\n");
    if (!(player->bits&PLAYER_ALIVE)) {
        ncdirect_set_fg_rgb(nc, BRIGHT_RED);
        printf("You're fucking dead!  Go to (R)eincarnations to live again.\n");
        return;
    }
    if (player->target && player->target->bits&PLAYER_ALIVE) {
        ncdirect_set_fg_rgb(nc, BRIGHT_RED);
        printf("You already have a target!  Go kill them first!\n");
        return;
    }
    if (npc_killer) {
        ncdirect_set_fg_rgb(nc, WHITE);
        printf("Congratulations, you're the only survivor!\n");
        printf("You get to kill some NPC's now while you wait for some fresh meat.\n\n");
    }
    ncdirect_set_fg_rgb(nc, BRIGHT_YELLOW);
    targets = find_untargeted_players(player, players);
    for (i=0; targets[i]; i++) {
        printf("%2d: %s\n", i+1, targets[i]->name);
    }
    printf("\n");
    str = ncdirect_readline(nc, "Which player (number) would you like to kill ? ");
    player_id = (unsigned short)strtoul(str, NULL, 10);
    free(str);
    if (!player_id || player_id > i) {
        ncdirect_set_fg_rgb(nc, BRIGHT_RED);
        printf("No such player number - skill issue?\n");
    } else if (!npc_killer && targets[player_id-1]->bits&PLAYER_NPC) {
        ncdirect_set_fg_rgb(nc, BRIGHT_RED);
        printf("You can't kill NPC's until you've killed all the players!\n");
    } else {
        player->target = targets[player_id-1];
        ncdirect_set_fg_rgb(nc, BRIGHT_CYAN);
        printf("Okay, your target is now %s, go get 'em!\n", player->target->name);
        write_player_data(players);
    }
    free(targets);
}

bool main_menu(struct ncdirect *nc, struct Player *player, struct Player *players) {
    uint32_t key;
    ncinput ni;
    char str[80];

    printf("\n\n");
    if (player->bits&PLAYER_ALIVE) {
        ncdirect_set_fg_rgb(nc, WHITE);
        center_string(nc, "I'm pleased to say, you are Alive!\n");
    } else {
        ncdirect_set_fg_rgb(nc, DARK_CYAN);
        center_string(nc, "I'm sorry to say, you are dead!\n");
    }
    printf("\n");
    ncdirect_set_fg_rgb(nc, BRIGHT_CYAN);
    if (player->target == NULL) {
        center_string(nc, "You do not have a target, use the (P)ick command to get one!\n");
    } else {
        sprintf(str, "Your target is %s!\n", player->target->name);
        center_string(nc, str);
    }
    printf("\n\n");
    ncdirect_set_fg_rgb(nc, BRIGHT_YELLOW);
    center_string(nc, "(E)nter the motel \n");
    center_string(nc, "(P)ick a target   \n");
    center_string(nc, "(O)bituaries      \n");
    center_string(nc, "(R)eincarnations  \n");
    center_string(nc, "(S)queals files   \n");
    center_string(nc, "(M)ost wanted list\n");
    center_string(nc, "(H)istory         \n");
    center_string(nc, "(I)nstructions    \n");
    center_string(nc, "(Q)uit            \n");
    printf("\n");
    ncdirect_set_fg_rgb(nc, BRIGHT_GREEN);
    center_string(nc, "Your command ? ");
    fflush(stdout);

    while (1) {
        key = ncdirect_get_blocking(nc, &ni);
        if (key == (uint32_t)-1) {
            printf("ERROR in receiving keypress, bailing!\n");
            return false;
        }
        if (ni.evtype && ni.evtype != NCTYPE_PRESS)
            continue;
        switch (key) {
            case 'e':
            case 'E':
                printf("E\n\n");
                if (!(player->bits&PLAYER_ALIVE)) {
                    ncdirect_set_fg_rgb(nc, BRIGHT_RED);
                    printf("\n\nYou're fucking dead!  Get (R)eincarnated first.\n");
                    return true;
                }
                player_start(nc, player, players);
                return true;
            case 'p':
            case 'P':
                printf("P\n\n");
                pick_target(nc, player, players);
                return true;
            case 'r':
            case 'R':
                printf("R\n\n");
                if (player->bits&PLAYER_ALIVE) {
                    ncdirect_set_fg_rgb(nc, BRIGHT_GREEN);
                    printf("You're already fucking alive. What more do you want?!\n");
                    return true;
                }
                ncdirect_set_fg_rgb(nc, BRIGHT_PURPLE);
                printf("By the grace of Fernando, you've been brought back to life! ");
                ncdirect_set_fg_rgb(nc, BROWN);
                printf("~~,=,^>\n");
                player->bits |= PLAYER_ALIVE;
                return true;
            case 'm':
            case 'M':
                printf("M\n\n");
                most_wanted(nc, players);
                return true;
            case 'o':
            case 'O':
                printf("O\n\n");
                display_obits(nc);
                return true;
            case 's':
            case 'S':
                printf("S\n\n");
                while (1) {
                    if (squeals_menu(nc, player, players))
                        return true;
                }
            case 'h':
            case 'H':
                printf("H\n\n");
                display_file(nc, "HISTORY");
                return true;
            case 'i':
            case 'I':
                printf("I\n\n");
                display_file(nc, "INSTRUCTIONS");
                return true;
            case 'q':
            case 'Q':
                printf("Q\n\n");
                ncdirect_set_fg_rgb(nc, BRIGHT_YELLOW);
                center_string(nc, "Thank you for using Fernandotel.");
                printf("\n");
                return false;
        }
    }

    return false;
}

struct Player * login_screen(struct ncdirect *nc, struct Player *players) {
    struct Player *player;
    char name[MAX_PLAYER_NAME+1];
    char password[MAX_PASSWORD+1];
    char *str;
    unsigned short attempts;

    for (attempts=0; attempts<3; attempts++) {
        str = ncdirect_readline(nc, "login: ");
        alphanumeric_only(str, str);
        strncpy(name, str, MAX_PLAYER_NAME);
        free(str);

        str = ncdirect_readline(nc, "password: ");
        alphanumeric_only(str, str);
        strncpy(password, str, MAX_PASSWORD);
        free(str);

        player = match_player_name(name, players);
        if (player == NULL) {
            printf("I'm sorry, it doesn't look like you have a reservation.\n");
            if (!yes_no(nc, "Would you like to stay with us"))
                return NULL;
            player = create_new_player(players);
            if (player == NULL) {
                printf("ERROR: Something went wrong when creating a new player. Bailing!\n");
                return NULL;
            }
            strncpy(player->name, name, MAX_PLAYER_NAME);
            strncpy(player->password, password, MAX_PASSWORD);
            write_player_data(players);
        }

        if (check_player_password(password, player))
            return player;
    }

    return NULL;
}

int main(int argc, char *argv[]) {
    struct ncdirect *nc;
    struct Player *players, *player;

    nc = ncdirect_init(NULL, NULL, 0);

    if (nc == NULL) {
        printf("Couldn't initialize notcurses.\n");
        return EXIT_FAILURE;
    }

    ncdirect_cursor_enable(nc);

    players = initialize_players();

    if (players == NULL) {
        printf("Couldn't initialize players.\n");
        ncdirect_stop(nc);
        return EXIT_FAILURE;
    }

    read_player_data(players);

    if (argc > 2 && strcmp(argv[1], "-u") == 0) {
        uc_str(argv[2]);
        player = find_player_by_name(players, argv[2]);
        if (player == NULL) {
            player = create_new_player(players);
            strcpy(player->name, argv[2]);
            strcpy(player->password, "*");
        }
    } else {
        player = login_screen(nc, players);
    }

    if ((unsigned long)player->moves_t / 86400 < (unsigned long)time(NULL) / 86400) {
        player->moves_t = time(NULL);
        player->moves = CONFIG_MOVES_PER_DAY;
    }

    if (!check_pid()) {
        printf("\nSorry, someone else is playing Fernandotel. Try again later!\n\n");
    } else {
        ncdirect_clear(nc);
        while (player) {
            if (!main_menu(nc, player, players))
                break;
        }
	unlink("fernandotel.pid");
    }

    return ncdirect_stop(nc) ? EXIT_FAILURE : EXIT_SUCCESS;
}
