/*
   I, the copyright holder of this work, hereby release it into the public
   domain. This applies worldwide. In case this is not legally possible: I
   grant anyone the right to use this work for any purpose, without any
   conditions, unless such conditions are required by law.
*/

#include "fernandotel.h"

struct Squeal * read_squeals_file() {
    FILE *file = fopen("squeals.csv", "r");
    char **csv_elements;
    char line[256];
    unsigned short lines, i;
    struct Squeal *ret;

    if (file == NULL)
        return NULL;

    lines = count_lines_in_file("squeals.csv");

    if (lines < 1) {
        fclose(file);
        return NULL;
    }

    ret = (struct Squeal *)malloc((lines+1)*sizeof(struct Squeal));

    for (i=0; fgets(line, 255, file) != NULL; i++) {
        csv_elements = csv_line_to_null_terminated_multiple(line);
        ret[i].squeal_t = strtoul(csv_elements[0], NULL, 10);
        strcpy(ret[i].name, csv_elements[1]);
        strcpy(ret[i].description, csv_elements[2]);
        ret[i].truthful = strtoul(csv_elements[3], NULL, 10) ? 1 : 0;
        free(csv_elements);
    }

    fclose(file);

    ret[i].truthful = SQUEAL_END;

    return ret;
}

bool compare_squeals(struct Squeal *squeal, struct Squeal *squeals) {
    unsigned short i;

    if (squeals == NULL)
        return false;

    for (i=0; squeals[i].truthful != SQUEAL_END; i++) {
        if (   strcmp(squeal->name, squeals[i].name) == 0
            && strcmp(squeal->description, squeals[i].description) == 0
        ) {
            return true;
        }
    }

    return false;
}

bool write_squeal(struct Squeal *squeal) {
    FILE *file = fopen("squeals.csv", "r");
    char str[25] = "fernando-squeals-XXXXXX";
    char line[256];
    int tmp = mkstemp(str);

    if (tmp == -1) {
        fclose(file);
        return false;
    }

    if (file != NULL) {
        while (fgets(line, 255, file) != NULL)
            dprintf(tmp, "%s", line);
        fclose(file);
    }

    dprintf(tmp, "%ld,\"%s\",\"%s\",%d\r\n",
        squeal->squeal_t,
        squeal->name,
        squeal->description,
        squeal->truthful ? 1 : 0
    );

    close(tmp);

    if (rename(str, "squeals.csv") == -1)
        return false;

    return true;
}
